
%% Generate x vector


t = (0:359)';
f0 = 0.075;
ph0 = pi/6;
f1 = 0.125; 
ph1 = -pi/6;
x = 2.5 * cos(2*pi*f0*t + ph0) + 3 * cos(2*pi*f1*t + ph1) + 4 * randn(size(t));

%% Test my implementation of the Goertzel algorithm
N = length(x);
f = (0:N-1)/N;

[mag, phase] = bhGoertzel(x, f);

figure; subplot(3,1,1); plot(1:N, x); ylabel('x with mean removed');  title('Goertzel algorithm');
        subplot(3,1,2); plot(f, mag); ylabel('Magnitude');
        subplot(3,1,3); plot(f, phase); ylabel('Phase'); xlabel('f');

        
XX = fft(x);
ff = (0:N-1)/N;
figure; subplot(3,1,1); plot(1:N, x); ylabel('x with mean removed'); title('MATLAB fft algorithm');
        subplot(3,1,2); plot(ff, abs(XX)); ylabel('Magnitude of FFT');
        subplot(3,1,3); plot(ff, angle(XX)); ylabel('Phase of FFT');
        
figure; subplot(2,1,1); plot(f, mag(:), f, abs(XX(:)), f, mag(:)-abs(XX(:))); legend('Goertzel', 'FFT', 'difference'); ylabel('Magnitude'); title('Goertzel vs. FFT');
        subplot(2,1,2); plot(f, unwrap(phase(:)), f, unwrap(angle(XX)), f, unwrap(phase(:))-unwrap(angle(XX))); ylabel('Phase'); xlabel('Normalized Frequency');
                        legend('Goertzel', 'FFT', 'difference');



%% test Atan() phase correction

t = 0:.01:40;
f0 = 0.1;
tst = exp(-j*2*pi*f0*t);
realPart = real(tst);
imagPart = imag(tst);

ix = realPart<0;
ph(ix) = atan(imagPart(ix) ./ realPart(ix)) + pi;
ix = realPart>=0 & imagPart>=0;
ph(ix) = atan(imagPart(ix) ./ realPart(ix));
ix = realPart>=0 & imagPart<0;
ph(ix)  = atan(imagPart(ix) ./ realPart(ix)) + 2 * pi;

figure; 
subplot(2,1,1); plot(t, real(tst), t, imag(tst)); legend('real(x)', 'imag(x)');
subplot(2,1,2); plot(t, ph, t, angle(tst)); legend('corrected', 'uncorrected'); 
set(gca,'YTick',-pi:pi/2:2*pi)
set(gca,'YTickLabel',{'-pi','-pi/2','0','pi/2','pi', '3pi/2', '2pi'})
